package com.seeyon.v3x.edoc.listener;

import java.util.Map;
import java.util.Queue;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.seeyon.apps.edoc.event.EdocAutoSkipEvent;
import com.seeyon.ctp.common.quartz.QuartzJob;
import com.seeyon.ctp.util.DBAgent;
import com.seeyon.ctp.util.annotation.ListenEvent;

public class EdocListener {
	private static Log log = LogFactory.getLog(EdocAutoSkipEvent.class);
	private QuartzJob affairIsOvertopTimeJob;
	@ListenEvent(event = EdocAutoSkipEvent.class,async = true)
	
	public void transOnAutoSkip(EdocAutoSkipEvent evt){
		final EdocAutoSkipEvent event = evt;
    	Queue<Map<String, String>> queues  = event.getQueues();
		while(!queues.isEmpty()){
			Map<String, String> map = queues.poll();
			if(map != null){
				try {
					Thread.sleep(5000); //5秒延迟，使意见区的意见有序
				} catch (InterruptedException e) {
					log.error("", e);
				}
				affairIsOvertopTimeJob.execute(map);
				DBAgent.commit();
			}
		}
          
	}
	
	public QuartzJob getAffairIsOvertopTimeJob() {
		return affairIsOvertopTimeJob;
	}
	public void setAffairIsOvertopTimeJob(QuartzJob affairIsOvertopTimeJob) {
		this.affairIsOvertopTimeJob = affairIsOvertopTimeJob;
	}
	
	
}
