<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ include file="../govdoc_header.jsp"%>
<!DOCTYPE html>
<html>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<title>高级查询</title>
<head>
<script type="text/javascript">
var listType = "${ctp:escapeJavascript(param.listType)}";
var govdocType = "${ctp:escapeJavascript(param.govdocType)}";
var configId = "${ctp:escapeJavascript(param.configId)}";

function OK(json) {
	if(json.type==1) {//确定
		var o = getConditionObj();
		if(o == false) {
			return;
		}
		return o;
	}
	if(json.type==2) {//重置
   		$("#combinedQueryDIV").clearform();
    }
}

function getConditionObj() {
	var o = new Object();
	o.listType = listType;
	o.govdocType = govdocType;
	o.configId = configId;
	o.condition = "com";
	//标题
	if($('#subject').val() != "") {
		o.subject = $('#subject').val();	
	}
	//公文文号
	if($('#docMark').val() != "") {
    	o.docMark = $('#docMark').val();
	}
    //内部文号
    if($('#serialNo').val() != "") {
    	o.serialNo = $('#serialNo').val();
    }
    //密级
    var secretLevel = $('#secretLevel').find("option:selected").val();
    if(secretLevel != "") {
    	o.secretLevel = secretLevel;
    }
    //紧急程度
    var urgentLevel = $('#urgentLevel').find("option:selected").val();
    if(urgentLevel != "") {
    	o.urgentLevel = urgentLevel;
    }
  	//发起人
  	if($('#startUserName').val() != "") {
		o.startUserName = $('#startUserName').val();
  	}
  	
    //发起时间
    if(!checkTime("startTime", o)) {
    	return false;
    }
    if(listType.indexOf("listPending") > -1 || listType.indexOf("listExchangeSendPending") > -1) { //待办
		//接收时间
		if(!checkTime("receiveTime", o)) {
			return false;
	    }
		
      	//处理期限
      	if(!checkTime("affairExpectedProcessTime", o)) {
      		return false;
	    }
      	
        //处理状态
        if($('#dealState').val() != "") {
			o.dealState = $('#dealState').val();
        }
	} else if(listType.indexOf("listDone") != -1 || listType.indexOf("listExchangeSendDone") != -1) { //已办
        //处理时间
        if(!checkTime("completeTime", o)) {
        	return false;
	    }

		//流程状态
		if( $('#flowState').val() != "") {	
			o.flowState = $('#flowState').val();
	   	}
	}
    return o;
}
       
</script>
</head>
<body class="h100b over_hidden">

<div class="form_area" id="combinedQueryDIV">

<form style="height: 100%;" name="addQuery" id="addQuery" method="post" class="align_center">

<table  style="height: 100%;width:98%;" border="0" cellSpacing="10" cellPadding="10">
	<!-- 标题 -->
	<tr>
	    <td align="right" nowrap="nowrap" width="25%">${ctp:i18n("cannel.display.column.subject.label")}：</td>
	    <td width="75%" align="left"><input id="subject"  type="text" name="subject"/></td>
	</tr>
	
	<!-- 公文文号 -->
	<tr>
	    <td align="right" nowrap="nowrap" width="3%">${ctp:i18n("govdoc.docMark.label")}：</td>
	    <td width="2%" align="left"><input id="docMark"  type="text" name="docMark"/></td>
	</tr>
	
	<!-- 内部文号 -->
	<tr>
	    <td align="right" nowrap="nowrap" width="3%">${ctp:i18n("govdoc.serialNo.label")}：</td>
	    <td width="2%" align="left"><input id="serialNo"  type="text" name="serialNo"/></td>
	</tr>
	
	<!-- 密级 -->
	<tr>
	    <td align="right" nowrap="nowrap" width="3%">${ctp:i18n("govdoc.secretLevel.label")}：</td>
	    <td width="2%" align="left">
	    	<select name="secretLevel" id="secretLevel" class="" style="width: 200px">
		        <option value="" selected>${ctp:i18n("common.pleaseSelect.label")}</option>
		        <c:forEach items="${secretLevelList }" var="bean">
		        <option value="${bean.enumvalue }">${bean.showvalue }</option>	
		        </c:forEach>
		    </select>
	    </td>
	</tr>
	
	<!-- 紧急程度 -->
	<tr>
	    <td align="right" nowrap="nowrap" width="3%">${ctp:i18n("govdoc.urgentLevel.label")}：</td>
	    <td width="2%" align="left">
	    	<select name="urgentLevel" id="urgentLevel" class="" style="width: 200px">
	            <option value="" selected>${ctp:i18n("common.pleaseSelect.label")}</option>
	            <c:forEach items="${urgentLevelList }" var="bean">
		        <option value="${bean.enumvalue }">${bean.showvalue }</option>	
		        </c:forEach>
	        </select>
	    </td>
	</tr>
   	
   	<!-- 发起人 -->
   	<tr>
        <td align="right" nowrap="nowrap" id="reportUnitTd" width="2%">${ctp:i18n("cannel.display.column.sendUser.label")}：</td>
        <td align="left"><input id="startUserName" width="2%" type="text" name="startUserName"/></td>
    </tr>
    
    <!-- 发起时间 -->
    <tr>
        <td align="right" nowrap="nowrap" id="reportUnitTd" width="2%">${ctp:i18n("common.date.sendtime.label")}：</td>
        <td align="left">
            <input id="from_startTime" style="width: 40%" class="comp" type="text" comp="type:'calendar',ifFormat:'%Y-%m-%d',showsTime:false,position:[120,10]" readonly>
            <span class="padding_lr_5">-</span>
            <input id="to_startTime" class="comp" style="width: 40%" type="text" comp="type:'calendar',ifFormat:'%Y-%m-%d',showsTime:false,position:[120,10]" readonly>
        </td>
    </tr>

	<c:if test="${fn:indexOf(param.listType, 'listPending') != -1 or fn:indexOf(param.listType, 'listExchangeSendPending') != -1 or fn:indexOf(param.listType, 'listExchangeSignPending') != -1}">
	<!-- 接收时间 -->
	<tr>
	    <td align="right" nowrap="nowrap" id="reportUnitTd" width="2%">${ctp:i18n("cannel.display.column.receiveTime.label")}：</td>
	    <td align="left">
	        <input id="from_receiveTime" style="width: 40%" class="comp" type="text" comp="type:'calendar',ifFormat:'%Y-%m-%d',showsTime:false,position:[120,10]" readonly>
	        <span class="padding_lr_5">-</span>
	        <input id="to_receiveTime" class="comp" style="width: 40%" type="text" comp="type:'calendar',ifFormat:'%Y-%m-%d',showsTime:false,position:[120,10]" readonly>
	    </td>
	</tr>
	</c:if>
	<c:if test="${fn:indexOf(param.listType, 'listPending') != -1 or fn:indexOf(param.listType, 'listExchangeSendPending') != -1}">
	<!-- 处理期限 -->
	<tr>
	    <td align="right" nowrap="nowrap" id="reportUnitTd" width="2%">${ctp:i18n("pending.deadlineDate.label") }：</td>
	    <td align="left">
	        <input id="from_expectedProcessTime" style="width: 40%" class="comp" type="text" comp="type:'calendar',ifFormat:'%Y-%m-%d',showsTime:false,position:[120,10]" readonly>
	        <span class="padding_lr_5">-</span>
	        <input id="to_expectedProcessTime" class="comp" style="width: 40%" type="text" comp="type:'calendar',ifFormat:'%Y-%m-%d',showsTime:false,position:[120,10]" readonly>
	    </td>
	</tr>
	<!-- 处理状态 -->
	<tr>
		<td align="right" nowrap="nowrap" id="reportUnitTd" width="2%">${ctp:i18n("collaboration.trans.label") }：</td>
	    <td align="left" width="10%" >
	   		<select id="dealState" name="dealState"  style="width: 50%">
	    	 	<option value="">${ctp:i18n("collaboration.newcoll.qxz")}</option>
	    	 	<option value="11">${ctp:i18n("collaboration.toolTip.label11") }</option>
	    		<option value="12">${ctp:i18n("collaboration.toolTip.label12") }</option>
	    	   	<option value="13">${ctp:i18n("collaboration.dealAttitude.temporaryAbeyance") }</option>
	    	    <option value="2">${ctp:i18n("collaboration.toolTip.label16") }</option>  
	    	    <option value="15">${ctp:i18n("collaboration.substate.16.label") }</option>
	    	</select>
	    </td>
	</tr>
	</c:if>

	<c:if test="${fn:indexOf(param.listType, 'listDone') != -1 or fn:indexOf(param.listType, 'listExchangeSendDone') != -1 or fn:indexOf(param.listType, 'listExchangeSignDone') != -1}">
	<!-- 处理时间 -->
	<tr>
	   <td align="right" nowrap="nowrap" id="reportUnitTd" width="2%">${ctp:i18n("common.date.donedate.label")}：</td>
	  <td align="left">
	      <input id="from_completeTime" style="width: 40%" class="comp" type="text" comp="type:'calendar',ifFormat:'%Y-%m-%d',showsTime:false,position:[120,10]" readonly>
	      <span class="padding_lr_5">-</span>
	      <input id="to_completeTime" class="comp" style="width: 40%" type="text" comp="type:'calendar',ifFormat:'%Y-%m-%d',showsTime:false,position:[120,10]" readonly>
	    </td>
	</tr>
	
	<!-- 流程状态 -->
	<tr>
	   <td align="right" nowrap="nowrap" id="reportUnitTd" width="2%">${ctp:i18n("collaboration.workFlowState.label") }：</td>
	 	<td align="left" width="10%" >
	 		<select id="flowState" name="flowState" style="width: 50%">
	 	 		<option value="">${ctp:i18n("collaboration.newcoll.qxz")}</option>
	 	  		<option value="3">${ctp:i18n("collaboration.ended")}</option>
	 	   		<option value="1">${ctp:i18n("collaboration.terminated")}</option>
	 		</select>
	    </td>
	</tr>
	</c:if>               

</table>
</form>
</div>
</body>
</html>