var grid;
var layout;
var curLastNorth = 100;//当前最大的north高度

function loadUE() {
	layout = $("#layout").layout();
	setListTableUI();
}

function setNorthHeight(action) {
	if(action == "Down") {
		layout.setNorth(curLastNorth);
		setListTableUI();	
	} else {
		layout.setNorth(0);
		setListTableUI();
	}
}

function setConditionUI(_this) {
	var mode = $(_this).attr('mode');
    var newMode = 'advance';
    var newHi = 280;
    curLastNorth = 280;

    var newModeName = '[' + $.i18n('govdoc.search.normalSearch') + ']';
    if ('advance' == mode) {
        newModeName = '[' + $.i18n('edoc.label.advancedSearch') + ']';
        newMode = 'normal';
        newHi = 120;
        curLastNorth = 120;
    }
    
    $(_this).text(newModeName);
    $(_this).attr('mode', newMode);
    $('#layout').layout().setNorth(newHi);
    
    $('#conditionForm table tr:not(:first-child)').toggleClass('hidden');
    var trNum = 6;
    if(listType == 'listRecRegister'){
        trNum = 5;
    }
    $('#conditionForm table tr:nth-child(n+'+trNum+')').show();
}

/**
 * 重新调整grid的布局
 */
function setListTableUI() {
    var cHi = $('#center').height();
    var tbHi = $('#toolbars').height();
    var hHi = $('.hDiv').height();
    var pHi = $('.pDiv').height();
    $('.flexigrid .bDiv').height(cHi - tbHi - hHi - pHi - 3);
}

function loadToolbar() {
    if(isFromSection) {//栏目查看的情况不初始化工具栏
        return;
    }
    
	var toolbarArray = new Array();
	toolbarArray.push({
        id : "exportExcelMenu",
        name : $.i18n('common.toolbar.exportExcel.label'),// 导出Excel
        className : "ico16 export_excel_16",
        click : function() {
        	doExcel();
        }
    });
//	if(listType != "listSignRegister") {
//		toolbarArray.push({
//            id : "pushToPortal",
//            name : $.i18n('common.search.PushHome.label'),// 推送首页
//            className : "ico16 sent_to_16",
//            click : function() {
//            	doPushHome();
//            }
//		});
//	}
	
	$("#toolbars").toolbar({
        isPager : false,
        toolbar : toolbarArray
    });
}

/**
 * 弹出框, 这个方法可以的话可以升级成组件
 * @param config = {title:dialog的标题，callbackFn:点确认后回调方法，msg:input上的提示语句，initValue:初始化值}
 */
function doPrompt(config) {
    var title = config.title || " ";
    var callbackFn = config.callbackFn;
    var msg = config.msg;
    var initValue = config.initValue;
    
    var promptPageParams = {
        initValue: initValue,
        msg: msg
    }
    
    var prompWin = $.dialog({
        
        url: _ctxPath + '/edocController.do?method=showPromptPage',
        width: 360,
        height: 148,
        title: title,//
        transParams: promptPageParams,
        targetWindow: getCtpTop(),
        closeParam: {
            'show': true,
            autoClose: false,
            handler: function () {
                prompWin.close();
            }
        },
        buttons: [{
            id: "okButton",
            text: $.i18n("common.button.ok.label"),
            handler: function () {
                if (callbackFn) {
                    var retValue = prompWin.getReturnValue();
                    callbackFn(retValue);
                } else {
                    prompWin.close();
                }
            }
        }, {
            id: "cancelButton",
            text: $.i18n("common.button.cancel.label"),
            handler: function () {
                prompWin.close();
            }
        }]
    });
    
    return prompWin;
}

/**
 * 初始化查询模式
 */
function loadEvent(type) {
    $('#advanceBtn').on('click', function () {
    	//resetQueryCondition();
        
        setConditionUI(this);
        setListTableUI();
    });
    
    // 查询统计
    $('#searchBtn').click(function(){
    	var o = getConditionObj();
        searchByCondition(o);
    });

    // 重置
    $('#queryReset').click(function(){
        resetQueryCondition();
    });
}

function getConditionObj() {
	var o = new Object();
    o.condition = 'register';
    o.listType = listType;
    if(!checkTime("startTime", o)) {
    	return;
    }
    if(!checkTime("signingDate", o)) {
    	return;
    }
    if(!checkTime("packTime", o)) {
    	return;
    }
    if($("#subject").val() != "") {
    	o.subject = $("#subject").val();
    }
    if($("#docMark").val() != "") {
    	o.docMark = $("#docMark").val();
    }
    if($("#serialNo").val() != "") {
    	o.serialNo = $("#serialNo").val();
    }
    if($("#sendDepartment").val() != "") {
    	o.sendDepartment = $("#sendDepartment").val();
    }
    if($("#sendUnit").val() != "") {
    	o.sendUnit = $("#sendUnit").val();
    }
    if($("#secretLevel").val() != "") {
    	o.secretLevel = $("#secretLevel").val();
    }
    if($("#issuer").val() != "") {
    	o.issuer = $("#issuer").val();
    }
    if($("#urgentLevel").val() != "") {
    	o.urgentLevel = $("#urgentLevel").val();
    }
    if($("#sendType").val() != "") {
    	o.sendType = $("#sendType").val();
    }
    if($("#docType").val() != "") {
    	o.docType = $("#docType").val();
    }
    if($("#sendTo").val() != "") {
    	o.sendTo = $("#sendTo").val();
    }
    if($("#createPerson").val() != "") {
    	o.createPerson = $("#createPerson").val();
    }
    if($("#pishiName").val() != "") {
    	o.pishiName = $("#pishiName").val();
    }
    if($("#pishiYear").val() != "") {
    	o.pishiYear = $("#pishiYear").val();
    }
    if($("#pishiNo").val() != "") {
    	o.pishiNo = $("#pishiNo").val();
    }
    if($("#undertaker").val() != "") {
    	o.undertaker = $("#undertaker").val();
    }
    if($("#undertakenoffice").val() != "") {
    	o.undertakenoffice = $("#undertakenoffice").val();
    }
    if($("#hasArchive").val() != "") {
    	o.hasArchive = $("#hasArchive").val();
    }
    return o;
}

/**
 * 重置查询区域的布局
 */
function resetQueryCondition() {
    $('#conditionForm input').each(function () {
        $(this).val('');
    });
    $('#conditionForm select').each(function () {
        $(this)[0].selectedIndex = 0;
    });
}

/**
 * 导出Excel
 */
function doExcel() {
     $("#columnDomain").html("");
     var listColumns = getListColumns();
     for(var i = 0; i < listColumns.length; i++) {
    	 var model = listColumns[i];
    	 $("#columnDomain").append('<input name="display" id="display" value="'+model["display"]+'" />');
    	 $("#columnDomain").append('<input name="name" id="name" value="'+model["name"]+'" />');
    	 
    	 //枚举配置ID
         var codeId = getRegexValue(model["codecfg"]);
         $("#columnDomain").append('<input name="codecfg" id="codecfg" value="'+codeId+'" />');
     }
     if($("#statTitle").val()=="") {
    	 $("#statTitle").val(statTitle);
     }
     var _url = edocListURL + "?method=listRegisterToExcel&listType="+listType;
     var domains = ["conditionForm", "columnDomain"];
     $("#queryCondition").jsonSubmit({
         domains : domains,
         debug : false,
         action: _url,
         callback: function(data) {
             if(typeof(callbackFn) == "function"){
                 callbackFn(data);
             }
         }
     });
}

var codecfgRegex = /codeId[ ]*?:[ ]*?(["'])([^ ]+?)[ ]*?\1/i;
function getRegexValue(codecfg) {
	//枚举配置ID
    var codeId = "";
    if(codecfg) {
        var tempCodecfg = codecfg;
        var ret = codecfgRegex.exec(tempCodecfg);
        if(ret){
            codeId = ret[2];
        }
    }
    return codeId;
}

function doPushHome() {
//    var toolbarId = "toolbars";
//    var promptObj = doPrompt({
//         title : $.i18n('common.search.PushHome.label'),// 推送首页
//         callbackFn : function(value) {
//             if(value==null || value == "") {//提示名称为空
//                 $.alert($.i18n("edoc.alert.fillPushName"));//请输入推送名称
//                 return;
//             }
//             if(value.length > 85) {//标题最长85
//                 $.alert($.i18n("edoc.alert.pushNameMaxSize", 85));//推送名称最大长度为85
//                 return;
//             }
//             promptObj.close();
//             
//             var url = _ctxPath + '/govdoc/stat.do?method=saveRegisterCondition&listType=' + listType;
//             var extendParams = {"pushConditionName" : value };
//             _doAjaxSubmitClomnAndQuery(url, function(data) {
//            	 $.infor($.i18n('edoc.push.success'));//推送成功!
//             }, extendParams);
//         },
//         msg : $.i18n('edoc.confirm.regiester.push', registerName),//您确认推送以下内容至首页空间的发文登记薄栏目吗？
//         initValue : defaultPubshName
//     });
}

/**
 * Ajax方式提交列和查询字段
 * @param url 提交地址
 * @param extendParam 扩展数据， 随queryDomain域提交，注意不要重名了
* @param callbackFn 回调函数
*/
function _doAjaxSubmitClomnAndQuery(url, callbackFn, extendParam) {
   if(url) {
       getQueryObject();

       var $columnDomain = $("#columnDomain");
       var $queryDomain = $("#queryDomain");
       
       $columnDomain.html("");
       $queryDomain.html("");
       
       //截取枚举的正则
       var codecfgRegex = /codeId[ ]*?:[ ]*?(["'])([^ ]+?)[ ]*?\1/i;
       var showColumns = getListColumns();
       for(var i = 0; i < showColumns.length; i++) {
           var model = showColumns[i];
           //拼接列form
           $columnDomain.append('<input name="display" id="display" value="'+model["display"]+'" />');
           $columnDomain.append('<input name="name" id="name" value="'+model["name"]+'" />');
           //枚举配置ID
           var codeId = "";
           if(model["codecfg"]){
               var tempCodecfg = model["codecfg"];
               var ret = codecfgRegex.exec(tempCodecfg);
               if(ret) {
                   codeId = ret[2];
               }
           }
           $columnDomain.append('<input name="codecfg" id="codecfg" value="'+codeId+'" />');
       }
       if(_queryObject) {
           $queryDomain.append('<input name="condition" id="condition" value="'+_queryType+'" />');
           for(var i = 0; i < _queryObject.length; i++){
               //查询条件处理
               var tempCondition = _queryObject[i];
               var sItemType = tempCondition["type"];
               var sItemCondition = tempCondition["condition"];
               var sItemValue = tempCondition["value"];
               
               if("datemulti" == sItemType && sItemValue) {//
                   sItemValue = sItemValue[0] + "," + sItemValue[1];
               }
               $queryDomain.append('<input name="'+sItemCondition+'" id="'+sItemCondition+'" value="'+escapeStringToHTML(sItemValue)+'" />');
           }
       }
       
       //扩展参数拼接
       if(extendParam){
           for(var key in extendParam) {
               $queryDomain.append('<input name="'+key+'" id="'+key+'" value="'+escapeStringToHTML(extendParam[key])+'" />');
           }
       }

       //提交
       var domains = ["columnDomain", "queryDomain"];
       $("#dynamicForm").jsonSubmit({
           domains : domains,
           debug : false,
           action:url,
           callback: function(data) {
               if(typeof(callbackFn) == "function"){
                   callbackFn(data);
               }
               //清空数据
               $columnDomain.html("");
               $queryDomain.html("");
           }
       });
   }
}

/**
 * 获取当前的查询条件到_queryObject
 * @param type
 */
function getQueryObject() {
    _queryObject = [];
    _queryType = 'compQuery';
    $('#conditionForm input,#conditionForm select').each(function () {
        var name = $(this).attr('name');
        if (name != null) {
            if (name.indexOf('Time') == -1 && name.indexOf('Date') == -1) {
                var qObject = new Object();
                qObject.type = '';
                qObject.condition = name;
                qObject.value = $(this).val().trim();
                _queryObject.push(qObject);
            }
        }

    });
    // 补充设置_queryObject
    var qObject = new Object();
    // 拟文日期
    var startTimeStart = $('#from_startTime').val().trim();
    var startTimeEnd = $('#to_startTime').val().trim();
    if(listType != 'listRecRegister') {
        // 签发日期
        var signingDateStart = $('#from_signingDate').val().trim();
        var signingDateEnd = $('#to_signingDate').val().trim();

        qObject.type = 'datemulti';
        qObject.condition = 'signingDate';
        qObject.value = [signingDateStart, signingDateEnd];
        _queryObject.push(qObject);
    }

    qObject = new Object();
    qObject.type = 'datemulti';
    if(listType == 'listRecRegister') {
        qObject.condition = 'recieveDate';
    }else{
        qObject.condition = 'startTime';
    }
    qObject.value = [startTimeStart, startTimeEnd];
    _queryObject.push(qObject);
}

//将显示列导出到数组中，用于导出
function getListColumns() {
	var allColumns = [];
	for(var i = 0; i < grid.p.colModel.length; i++) {
		var model = grid.p.colModel[i];
		allColumns.push(model);
	}
	return allColumns;
}

function dbclickRow(data, rowIndex, colIndex) {
	if(!(data.affairId)) {
		data.affairApp = 4;
		if(data.govdocType == 0) {
			if(data.edocType == 0) {
				data.affairSubApp = 19;
			} else if(data.edocType == 1) {
				data.affairSubApp = 20;
			} else if(data.edocType == 2) {
				data.affairSubApp = 21;
			}
		} else {
			data.affairSubApp = data.govdocType;
		}
	}
	var _url = getListClickUrl(data, "formStatistical");
	if(!_url) {
		return;
	}
	
	var _title = data.subject;
	openGovdocDialog(_url, escapeStringToHTML(_title));
}
