/**
 * 页面加载初始化
 */
$(document).ready(function() {
	loadData();
	if(!isFromSection) {
		loadToolbar();
		loadUE();
		loadEvent();
		listAddWaterMark('listRecRegister');
	}
});

/**
 * 列表数据加载
 */
function loadData() {
	var colModels = new Array();
	colModels.push({
        display : $.i18n("edoc.element.subject"),//公文标题
        id:'subject',
        name : 'subject',
        width : '30%',
        sortable : true,
        align : 'left',
        hide : false
    });
    colModels.push({
        display : $.i18n('edoc.element.wordno.label'),//来文文号/公文文号
        name : 'docMark',
        width : '10%',
        sortable : true,
        align : 'left',
        hide : false
    });
    colModels.push( {
		display :$.i18n('govdoc.currentNodesInfo.label'),// 当前待办人
		name : 'currentNodesInfo',
		width : '10%',
		sortable : true,
		align : 'left',
		hide : false
	});
    colModels.push( {
    	display : $.i18n('govdoc.element.leaderCommondSort.label'),//领导批示编号
    	name : 'leaderCommondNo',
    	width : '10%',
    	sortable : true,
    	align : 'left',
    	hide : false
    });
    colModels.push({
        display : $.i18n('edoc.element.wordinno.label'),//收文编号/内部文号
        name : 'serialNo',
        width : '10%',
        align : 'left',
        sortable : true,
        hide : false
    });
    colModels.push({
        display : $.i18n('edoc.edoctitle.fromUnit.label'),//来文单位
        name : 'sendUnit',
        width : '10%',
        sortable : true,
        align : 'left',
        hide : false
    });
    colModels.push({
    	display : $.i18n('edoc.element.signperson'),// 签收人
		name : 'signPerson',
		width : '10%',
		sortable : true,
		align : 'left',
		hide : false
    });
    colModels.push({
        display : $.i18n('govdoc.element.doctype2'),//公文种类
        name : 'docType',
        width : '10%',
        sortable : true,
        align : 'left',
        hide : false
    });
    colModels.push( {
		display : $.i18n('edoc.element.issuer'),// 签发人
		name : 'issuer',
		width : '10%',
		sortable : true,
		align : 'left',
		hide : false
	});
    colModels.push({
        display : $.i18n('edoc.element.communication.date'),//来文日期(签收日期)
        name : 'receiptDate',
        width : '10%',
        sortable : true,
        sortType : "date",
        dataType : "date",
        align : 'left',
        hide : true
    });
    colModels.push({
        display : $.i18n('edoc.element.undertaker'),//承办人
        name : 'undertaker',
        width : '10%',
        sortable : true,
        align : 'left',
        hide : true
    });
    colModels.push({
        display : $.i18n('govdoc.element.receive.distributer'),//分办人
        name : 'distributer',
        width : '10%',
        sortable : true,
        align : 'left',
        hide : true
    });
    colModels.push({
        display : $.i18n('govdoc.stat.flowstat.label'),//流转状态
        name:'summaryTransferStatusName',
        width:'10%',
        sortable: true,
        align: 'left',
        hide: true
    });
	colModels.push({
	    display : $.i18n('edoc.edoctitle.disDate.label'),//分办日期
	    name : 'createTime',
	    width : '10%',
	    sortable : true,
	    sortType : "date",
	    align : 'left',
	    dataType : "date",
	    hide : true
	});
	colModels.push({
	    display : $.i18n('edoc.element.secretlevel.simple'),//密级
	    name : 'secretLevel',
	    width : '10%',
	    sortable : true,
	    align : 'left',
	    codecfg : "codeId:'edoc_secret_level'",
	    hide : true
	});
	colModels.push({
	    display : $.i18n('edoc.element.keepperiod'),//保密期限
	    name : 'keepPeriod',
	    width : '10%',
	    sortable : true,
	    align : 'left',
	    codecfg : "codeId:'edoc_keep_period'",
	    hide : true
	});
	colModels.push({
	    display : $.i18n('edoc.element.urgentlevel'),//紧急程度
	    name : 'urgentLevel',
	    width : '10%',
	    sortable : true,
	    align : 'left',
	    codecfg : "codeId:'edoc_urgent_level'",
	    hide : true
	});
	
	if(isFromSection) {//栏目查看的情况不初始化工具栏
		if(queryCol != "") {
			var colums = queryCol.split(",");
	        if(colums.length > 0) {
	        	var sectionModels = [];
	        	for(var i = 0; i < colums.length; i++) {
	                for(var k = 0; k < colModels.length; k++) {
	                    if(colums[i] == colModels[k]["name"]) {
	                    	colModels[k]["hide"] = false;
	                        sectionModels.push(colModels[k]);
	                    }
	                }
	            }
	        	colModels = sectionModels;
	        }//colums.length > 0
		}//queryCol != ""
        
        $("#layout_north").hide();
        $("#center").css("top","0").css("height","100%");
        $("#northSp_layout").hide();
    }
    
	grid = $('#listRecRegister').ajaxgrid({
		colModel : colModels,
		click : dbclickRow,
		render : rend,
		height : 200,
		showTableToggleBtn : true,
		parentId : $('.layout_center').eq(0).attr('id'),
		vChange : false,
		vChangeParam : {
			overflow : "hidden",
			autoResize : true
		},
		isHaveIframe : false,
		slideToggleBtn : false,
		managerName : "govdocListManager",
		managerMethod : "findRecRegisterList",
        usepager : !isFromSection
	});
}

/**
 * 重新加载列表
 */
function searchByCondition(o) {
    $("#listRecRegister").ajaxgridLoad(o);
}

/**
 * 列表数据回填
 * @param txt
 * @param data
 * @param r
 * @param c
 * @param col
 * @returns
 */
function rend(txt, data, r, c, col) {
	if (null == txt) {// 修正 如果是未讀，那麼會顯示null字符串
		txt = "";
	}

	if (col.name === "subject") {// 标题
		txt = getListSubjectTxt(txt, data, true, true, true, true, true, true, true);
	} else if(col.name === "startUserName") {//发起人
		txt = getListRedColorTxt(txt, data);
	} else if(col.name === "receiptDate" || col.name === "createTime") {//来文日期/分办日期
		if(txt != null && txt.length > 10) {
			txt = txt.substring(0, 10);
		}
	}
	
	return txt;
}

