﻿﻿
/*******************************************************************************
 * 流式工具函数
 */
var WP = {
	// 内部函数请勿调用-生成随机串
	_randomString : function(l) {
		var x = "0123456789qwertyuioplkjhgfdsazxcvbnm";
		var tmp = "";
		for (var i = 0; i < l; i++) {
			tmp += x.charAt(Math.ceil(Math.random() * 100000000) % x.length);
		}
		return tmp;
	}, // 判断参数是否是数组
	_isArray : function(v) {
		return Object.prototype.toString.call(v) === "[object Array]";
	},
	_each : function(o, fn) {
		if (this._isArray(o)) {
			for (var i = 0, ol = o.length, val = o[0]; i < ol
					&& fn.call(val, i, val) !== false; val = o[++i]) {
			}
		} else {
			for ( var i in o) {
				if (fn.call(o[i], i, o[i]) === false) {
					return o;// break;
				}
			}
		}
		return o;
	},
	// 对字符串进行转义
	escape : function(s) {
		return ('' + s).replace(/["'\\\n\r\u2028\u2029]/g, function(character) {
			// http://www.ecma-international.org/ecma-262/5.1/#sec-7.8.4
			switch (character) {
			case '"':
			case "'":
			case '\\':
				return '\\' + character
			case '\n':
				return '\\n'
			case '\r':
				return '\\r'
			case '\u2028':
				return '\\u2028'
			case '\u2029':
				return '\\u2029'
			}
		});
	},
	getOS : function() {
		var sUserAgent = navigator.userAgent;
		var isWin = (navigator.platform == "Win32")
				|| (navigator.platform == "Windows");
		var isMac = (navigator.platform == "Mac68K")
				|| (navigator.platform == "MacPPC")
				|| (navigator.platform == "Macintosh")
				|| (navigator.platform == "MacIntel");
		if (isMac)
			return "Mac";
		var isUnix = (navigator.platform == "X11") && !isWin && !isMac;
		if (isUnix)
			return "Unix";
		var isLinux = (String(navigator.platform).indexOf("Linux") > -1);
		if (isLinux)
			return "Linux";
		if (isWin) {
			var isWin2K = sUserAgent.indexOf("Windows NT 5.0") > -1
					|| sUserAgent.indexOf("Windows 2000") > -1;
			if (isWin2K)
				return "Win2000";
			var isWinXP = sUserAgent.indexOf("Windows NT 5.1") > -1
					|| sUserAgent.indexOf("Windows XP") > -1;
			if (isWinXP)
				return "WinXP";
			var isWin2003 = sUserAgent.indexOf("Windows NT 5.2") > -1
					|| sUserAgent.indexOf("Windows 2003") > -1;
			if (isWin2003)
				return "Win2003";
			var isWinVista = sUserAgent.indexOf("Windows NT 6.0") > -1
					|| sUserAgent.indexOf("Windows Vista") > -1;
			if (isWinVista)
				return "WinVista";
			var isWin7 = sUserAgent.indexOf("Windows NT 6.1") > -1
					|| sUserAgent.indexOf("Windows 7") > -1;
			if (isWin7)
				return "Win7";
			var isWin8 = sUserAgent.indexOf("Windows NT 6.1") > -1
					|| sUserAgent.indexOf("Windows 8") > -1;
			if (isWin8)
				return "Win8";
		}
		return "Win";
	}
};
/*******************************************************************************
 * 功能说明： 流式控件封装对象 参数说明： 控件类型暂时取值只有WPS和YOZO
 ******************************************************************************/
WP.OBJ = function(type) {
	this.ocxType = type;// 控件类型暂时取值只有WPS和YOZO
	this.os = WP.getOS();// 判断当前系统类型
	var ocx = null;// 控件
	var app = null;// linux下wps为ocx.Application;其他为控件对象(ocx)
	this.divId = null;// 控件所在DIV的标识(未使用)
	var currObjectId = null;// 当前控件标识
	// var Interval_app = null;//定时器标识
	var interMap = {};
	var isLoaded = false;
	this.Status = "";// 操作状态信息描述
	this.WebObject;
	this.isLoadTemplate = false;
	this.Template = "";
	this.execFunction = function(mtd, args) {
		var obj_app = this.getApp();
		var wp = this;
		if (obj_app == null || obj_app == undefined) {
			var Interval_app = setInterval(function() {
				interValAppFun(mtd, wp, args)
			}, 1000);
			interMap[mtd] = Interval_app;
			window.console && console.log("obj_app == null " + mtd + " : " + args);
		} else {
			window.console && console.log("appExec " + mtd + " : " + args);
			var vapp = appExec(obj_app, mtd, args);
			return vapp;

		}
	};
	// 执行控件的方法
	var _eval = function(o, m, args) {
		var arg = "";
		WP._each(args, function(i, v) {
			if (i > 0) {
				arg += ", ";
			}
			if (typeof (v) === "string") {
				arg += "\"" + WP.escape(v) + "\"";
			} else {
				arg += v;
			}
		});
		try {
			return eval("o." + m + "(" + arg + ")");
		} catch (e) {
			window.console && console.log("Eval " + m + " : " + e);
		}
	}
	var appExec = function(myApp, mtd, args) {
		return _eval(myApp, mtd, args);
	};
	var interValAppFun = function(mtd, obj, args) {
		ocx = document.getElementById(currObjectId);
		if (ocx) {
			if ("WPS" == obj.ocxType && obj.os.indexOf('Linux') == 0) {
				app = ocx.Application;
			} else {
				app = ocx;
			}
		}
		if (app) {
			var vInt = interMap[mtd];
			if (vInt) {
				clearInterval(vInt);
			}
			return appExec(app, mtd, args);
		}
	};
	this.getApp = function() {
		if (ocx == null || ocx == undefined) {
			ocx = document.getElementById(currObjectId);
		}
		if (ocx == null || ocx == undefined) {
			return undefined;
		} else {
			if ("WPS" == this.ocxType) {
				if (this.os.indexOf('Linux') == 0) {
					if (app == null || typeof (app) == "undefined") {
						app = ocx.Application;
					}
				} else if (this.os.indexOf('Win') == 0 && ocx.object != null) {
					app = ocx.object;
				}
				if(app){
					return app;
				}
			}else{
				return ocx;
			}

		}
	};

	this.getType = function() {
		return this.ocxType;
	};
	/** *********************************************标准定义接口结束*********************************************************** */
	this.init = function(tagID, width, height) {
		isLoadTemplate = false;
		this.divId = tagID;
		var rand = WP._randomString(5);
		var _id = "WebOffice";
		currObjectId = _id;
		var divObj = document.getElementById(tagID);
		this.app = null;
		if ("WPS" == this.ocxType) {
			var codes = [];
			if (this.os.toLowerCase().indexOf('win') == 0) {
					codes.push('<object id="WebOffice" hspace=0 vspace=0 height=' + height
							+ ' width=' + width + ' ');
					codes
							.push('data=data:application/x-oleobject;base64,7Kd9juwHQ0OBQYiirbY6XwEABAA7DwMAAgAEAB0AAAADAAQAgICAAAQABAD///8ABQBcAFgAAABLAGkAbgBnAHMAbwBmAHQAIABBAGMAdABpAHYAZQBYACAARABvAGMAdQBtAGUAbgB0ACAARgByAGEAbQBlACAAQwBvAG4AdAByAG8AbAAgADEALgAwAAAA ');
					codes
							.push('classid=clsid:8E7DA7EC-07EC-4343-8141-88A2ADB63A5F viewastext=VIEWASTEXT></object> ');
			} else if (this.os.toLowerCase().indexOf('linux') == 0) {
				codes
						.push("<object name='WebOffice' id='WebOffice' type='application/x-wps'  data='/seeyon/common/office/wps/Normal.wpt?v="+new Date().getTime()+"' width='100%'  height='"+height+"'  wpsextpara='-w'> <param name='Enabled' value='1'/> <param value='transparent' name='wmode'/></object>");
			}
			divObj.innerHTML = codes.join("");
		} else if ("YOZO" == this.ocxType) {
			divObj.innerHTML = "<APPLET archive='yozoapplet.jar' code='com.yozosoft.ocx.applet.YOZODTApplet.class' width="
					+ width
					+ " height="
					+ height
					+ " codebase='plugin' MAYSCRIPT=true id =" + _id + ">";
			+"<PARAM name='java_arguments' value='-Dsun.java2d.d3d=false -Xmx512m'></APPLET>";
		}
		//ocx = document.getElementById("WebOffice");
		return ocx;
	};
	/***************************************************************************
	 * 功能说明： 创建空文件 参数说明： Type固定取值为uot 返回值说明： true表示接口调用成功，功能能够实现；
	 * false表示接口调用失败，功能未能实现。
	 **************************************************************************/
	this.createDocument = function(type) {
		var rs = false;
		var app = this.getApp();
		if (app) {
			try {
				rs = app.createDocument(type);
			} catch (e) {
				alert(e);
			}
		} else {
			var arr = [ type ];
			rs = this.execFunction("createDocument", arr);
		}
		return rs;

	};
	/***************************************************************************
	 * 功能说明： 如果扩展名是文档模板uot，就按模板打开 返回值说明： true表示接口调用成功，功能能够实现；
	 * false表示接口调用失败，功能未能实现。
	 **************************************************************************/
	this.openDocument = function(fileName, readOnly) {
		var app = this.getApp();
		var rs = false;
		if (app) {
			rs = app.openDocument(fileName, readOnly);
		} else {
			var arr = [ fileName, readOnly ];
			rs = this.execFunction("openDocument", arr);
			rs = true;
		}
		return rs;

	};
	/***************************************************************************
	 * 功能说明： 如果扩展名是文档模板uot，就按模板打开。 参数说明： 参数1：URL模板地址； 参数2：readOnly是否只读。 返回值说明：
	 * true表示接口调用成功，功能能够实现； false表示接口调用失败，功能未能实现。
	 **************************************************************************/
	this.openDocumentRemote = function(URL, readOnly) {
		var rs = false;
		var app = this.getApp();
		if (app) {
			rs = app.openDocumentRemote(URL, readOnly);
		} else {
			var arr = [ URL, readOnly ];
			rs = this.execFunction("openDocumentRemote", arr);
			rs = true;
		}
		return rs;
	};

	/***************************************************************************
	 * 功能说明： 保存在本地,扩展名是模板则保存为模板,不弹出对话框。 参数说明： fileName=全路径包括扩展名。 返回值说明：
	 * true表示接口调用成功，功能能够实现； false表示接口调用失败，功能未能实现。
	 **************************************************************************/
	this.saveAs = function(fileName) {
		var app = this.getApp();
		var rs = false;
		if (app) {
			rs = app.saveAs(fileName);
		} else {
			var arr = [ fileName ];
			rs = this.execFunction("saveAs", arr);
		}
		return rs;
	};
	/***************************************************************************
	 * 功能说明： 保存在本地,扩展名是模板则保存为模板,弹出对话框。 返回值说明： true表示接口调用成功，功能能够实现；
	 * false表示接口调用失败，功能未能实现。
	 **************************************************************************/
	this.saveAs = function() {
		var app = this.getApp();
		var rs = false;
		if (app) {
			rs = app.saveAs();
		} else {
			rs = this.execFunction("saveAs", null);
		}
		return rs;
	};
	/***************************************************************************
	 * 功能说明： URL:OA提供的接收页面;也可以是个地址 参数说明： URL 保存的位置； fileName 文件名。 返回值说明：
	 * true表示接口调用成功，功能能够实现； false表示接口调用失败，功能未能实现。
	 **************************************************************************/
	this.saveURL = function(url, fileName) {
		var app = this.getApp();
		var rs = false;
		if (app) {
			rs = app.saveURL(url, fileName);
		} else {
			var arr = [ url, fileName ];
			if(this.ocx){
				rs = this.ocx.execFunction("saveURL", arr);
			}
		}
		return rs;
	};
	/***************************************************************************
	 * 功能说明： URL:OA提供版式文件保存位置的地址 参数说明： URL 保存的位置； fileName 文件名。 返回值说明：
	 * true表示接口调用成功，功能能够实现； false表示接口调用失败，功能未能实现。
	 **************************************************************************/
	this.saveOFD = function(url) {
		var app = this.getApp();
		var rs = false;
		if (app) {
			rs = app.saveURL(url, Math.random() * 100000 + ".ofd");
		} else {
			var arr = [ url, "ofd" ];
			if(this.ocx){
				rs = this.ocx.execFunction("saveURL", arr);
			}
		}
		return rs;
	};
	this.savePDF = function(url) {
		var app = this.getApp();
		var rs = false;
		if (app) {
			rs = app.DocObj.Application.ExportAsFixedFormat(url,17);//saveURL(url, Math.random() * 100000 + ".ofd");
		} else {
			//var arr = [ url, "pdf" ];
		//	rs = this.ocx.execFunction("saveURL", arr);
		}
		return rs;
	};

	/***************************************************************************
	 * 不调对话框打印 返回值说明： true表示接口调用成功，功能能够实现； false表示接口调用失败，功能未能实现
	 **************************************************************************/
	this.print = function() {
		var app = this.getApp();
		var rs = false;
		if (app) {
			rs = app.print();
		} else {
			rs = this.execFunction("print", null);
		}
		return rs;
	};
	/***************************************************************************
	 * 打印预览
	 **************************************************************************/
	this.printPre = function() {
		var app = this.getApp();
		var rs = false;
		if (app) {
			rs = app.ActiveDocument.PrintPreview();
		}
		return true;
	};

	/***************************************************************************
	 * 打印/不打印修订文字 参数说明： 0=打印修订状态； 1=打印原始状态(修订前)； 2=打印最终状态(修订后)。 返回值说明：
	 * true表示接口调用成功，功能能够实现； false表示接口调用失败，功能未能实现。
	 **************************************************************************/
	this.printRevision = function(enable) {
		var app = this.getApp();
		var rs = false;
		if (app) {
			rs = app.printRevision(enable);
		} else {
			var arr = [ enable ];
			rs = this.execFunction("printRevision", arr);
		}
		return rs;

	};

	/***************************************************************************
	 * 功能说明： 关闭文档。 返回值说明： true表示接口调用成功，功能能够实现； false表示接口调用失败，功能未能实现。
	 **************************************************************************/
	this.close = function() {
		var app = this.getApp();
		var rs = false;
		if (app) {
			rs = app.close();
		} else {
			rs = this.execFunction("close", null);
		}
		return rs;
	};

	/***************************************************************************
	 * 功能说明： 动态设置为文档只读或恢复可编辑。 参数说明： true=不可编辑。 false=可编辑。 返回值说明：
	 * true表示接口调用成功，功能能够实现； false表示接口调用失败，功能未能实现
	 **************************************************************************/
	this.enableProtect = function(enable) {
		var app = this.getApp();
		var rs = false;
		if (app) {
			rs = app.enableProtect(enable);
		} else {
			var arr = [ enable ];
			rs = this.execFunction("enableProtect", arr);
		}
		return rs;

	};

	/***************************************************************************
	 * 功能说明： 显示或隐藏全部工具菜单。 参数说明： true=启用。 false=禁止。 返回值说明： true表示接口调用成功，功能能够实现；
	 * false表示接口调用失败，功能未能实现
	 **************************************************************************/
	this.setToolbarAllVisible = function(enable) {
		var app = this.getApp();
		var rs = false;
		window.console && console.log("setToolbarAllVisible..."+enable);
		if (app) {
			rs = app.setToolbarAllVisible(enable);
		} else {
			var arr = [ enable ];
			rs = this.execFunction("setToolbarAllVisible", arr);
		}
		return rs;
	};
	/***************************************************************************
	 * 功能说明： 启用或禁止复制 参数说明： true=启用。 false=禁止。 返回值说明： true表示接口调用成功，功能能够实现；
	 * false表示接口调用失败，功能未能实现。
	 **************************************************************************/
	this.enableCopy = function(enable) {
		var app = this.getApp();
		var rs = false;
		if (app) {
			rs = app.enableCopy(enable);
		} else {
			var arr = [ enable ];
			rs = this.execFunction("enableCopy", arr);
		}
		return rs;
	};

	/***************************************************************************
	 * 功能说明： 启用或禁止剪切 参数说明： true=启用。 false=禁止。 返回值说明： true表示接口调用成功，功能能够实现；
	 * false表示接口调用失败，功能未能实现。
	 **************************************************************************/
	this.enableCut = function(enable) {
		var app = this.getApp();
		var rs = false;
		if (app) {
			rs = app.enableCut(enable);
		} else {
			var arr = [ enable ];
			rs = this.execFunction("enableCut", arr);
		}
		return rs;

	};

	/***************************************************************************
	 * 功能说明： 开启或停止修订。 参数说明： true=开启。 false=停止。 返回值说明： true表示接口调用成功，功能能够实现；
	 * false表示接口调用失败，功能未能实现。
	 **************************************************************************/
	this.enableRevision = function(enable) {
		var app = this.getApp();
		var rs = false;
		if (app) {
			rs = app.enableRevision(enable);
		} else {
			var arr = [ enable ];
			rs = this.execFunction("enableRevision", arr);
		}
		return rs;
	};
	/***************************************************************************
	 * 功能说明： 启用工具栏中接受修订的按钮。 参数说明： true=开启。 false=停止。 返回值说明： true表示接口调用成功，功能能够实现；
	 * false表示接口调用失败，功能未能实现。
	 **************************************************************************/
	this.enableRevisionAcceptCommand = function() {
		var app = this.getApp();
		var rs = false;
		if (app) {
			rs = app.enableRevisionAcceptCommand(false);
		} else {
			var arr = [ false ];
			rs = this.execFunction("enableRevisionAcceptCommand", arr);
		}
		return rs;
	};
	/***************************************************************************
	 * 功能说明： 禁止工具栏中接受修订的按钮。 参数说明： true=开启。 false=停止。 返回值说明： true表示接口调用成功，功能能够实现；
	 * false表示接口调用失败，功能未能实现。
	 **************************************************************************/
	this.enableRevisionRejectCommand = function() {
		var app = this.getApp();
		var rs = false;
		if (app) {
			rs = app.enableRevisionAcceptCommand(false);
		} else {
			var arr = [ false ];
			rs = this.execFunction("enableRevisionAcceptCommand", arr);
		}
		return rs;
	};

	/***************************************************************************
	 * 用于公文正文插图，在当前光标位置嵌入式，用户可调大小。 pictureFile:本地图片用文件名，远程图片用URL。
	 **************************************************************************/
	this.insertPicture = function(pictureFile) {
		var app = this.getApp();
		var rs = false;
		if (app) {
			rs = app.insertPicture(pictureFile);
		} else {
			var arr = [ pictureFile ];
			rs = this.execFunction("insertPicture", arr);
		}
		return rs;
	};

	/***************************************************************************
	 * 本地/URL图片插入到文档指定位置,用于章,二维码 返回值说明： true表示接口调用成功，功能能够实现；
	 * false表示接口调用失败，功能未能实现。
	 **************************************************************************/
	this.insertPicture = function(pictureFile, left, top, width, height) {
		var app = this.getApp();
		var rs = false;
		if (app) {
			rs = app.insertPicture(pictureFile);
		} else {
			var arr = [ pictureFile, left, top, width, height ];
			rs = this.execFunction("insertPicture", arr);
		}
		return rs;
	};

	/***************************************************************************
	 * 提取全文文本 返回值说明： 当前文档的文本内容。
	 **************************************************************************/
	this.getText = function() {
		var app = this.getApp();
		var rs = "";
		if (app) {
			rs = app.getText();
		} else {
			rs = this.execFunction("getText", null);
		}
		return rs;
	};

	/***************************************************************************
	 * 光标从当前位置执行退格操作 参数：无 返回值说明： true表示接口调用成功，功能能够实现； false表示接口调用失败，功能未能实现。
	 **************************************************************************/
	this.backspace = function() {
		window.console && console.log("backspace...");
		var app = this.getApp();
		var rs = false;
		if (app) {
			rs = app.backspace();
		} else {
			rs = this.execFunction("backspace", null);
		}
		return rs;
	};

	/***************************************************************************
	 * 前光标位置插入文本内容 参数：text 待插入的文本内容 返回值说明： true表示接口调用成功，功能能够实现；
	 * false表示接口调用失败，功能未能实现。
	 **************************************************************************/
	this.insertText = function(text) {
		var app = this.getApp();
		var rs = false;
		if (app) {
			rs = app.insertText(text);
		} else {
			var arr = [ text ];
			rs = this.execFunction("insertText", arr);
		}
		return rs;
	};

	/***************************************************************************
	 * 设置公文域唯一标识 参数：docid 公文唯一标识 返回值说明： true表示接口调用成功，功能能够实现；
	 * false表示接口调用失败，功能未能实现。
	 **************************************************************************/
	this.setDocumentId = function(docid) {
		if (typeof (docid) == "undefined" || docid == "") {
			return;
		}
		var app = this.getApp();
		var rs = false;
		if (app) {
			rs = app.setDocumentId(docid);
		} else {
			var arr = [ docid ];
			rs = this.execFunction("setDocumentId", arr);
		}
		return rs;
	};
	/***************************************************************************
	 * 获取公文唯一标识 返回值说明： 返回当前设置的公文唯一标识
	 **************************************************************************/
	this.getDocumentId = function() {
		var app = this.getApp();
		var rs = false;
		if (app) {
			rs = app.getDocumentId();
		} else {
			rs = this.execFunction("getDocumentId", null);
		}
		return rs;
	};

	/***************************************************************************
	 * 是否显示修订信息 参数1：isshow 布尔类型，是否显示修订信息。 返回值说明： true表示接口调用成功，功能能够实现；
	 * false表示接口调用失败，功能未能实现。
	 **************************************************************************/
	this.showRevision = function(isshow) {
		var app = this.getApp();
		var rs = false;
		var _val = 2;
		if (isshow) {
			_val = 3;
		}
		if (app) {
			rs = app.showRevision(_val);
		} else {
			var arr = [ _val ];
			this.execFunction("showRevision", arr);
		}
		return rs;
	};
	/**
	 * 功能说明： 获取所有公文域的 ID。 接口原型： array getAllDocumentField()。 参数说明：无。 返回值说明：
	 * 全部公文域 id 的字符串列表。
	 */
	this.getAllDocumentField = function() {
		var app = this.getApp();
		if (app) {
			rs = app.getAllDocumentField();
		} else {
			var arr = [];
			rs = this.execFunction("getAllDocumentField", arr);
		}
		return rs;
	};
	
	/**
	 * 功能说明： 判断公文域是否存在。 参数说明：公文域id。 返回值说明：true/false
	 */
	this.isExists = function(DocumentFieldId) {
		var app = this.getApp();
		if (app) {
			rs = app.isExists(DocumentFieldId);
		} else {
			var arr = [DocumentFieldId];
			rs = this.execFunction("isExists", arr);
		}
		return rs;
	};
	this.insertDocumentField = function(id) {
		var app = this.getApp();
		if (app) {
			rs = app.insertDocumentField(id);
		} else {
			var arr = [ id ];
			this.execFunction("insertDocumentField", arr);
		}
		return rs;
	};
	/**
	 * 功能说明： 删除指定ID的公文域 。 参数说明：id 待删除公文域标识。 返回值说明： true 表示接口调用成功，功能能够实现； false
	 * 表示接口调用成功，功能未实现；
	 */
	this.deleteDocumentField = function(id) {
		var app = this.getApp();
		if (app) {
			rs = app.deleteDocumentField(id);
		} else {
			var arr = [ id ];
			this.execFunction("deleteDocumentField", arr);
		}
		return rs;
	};
	/**
	 * 功能说明： 指定公文域是否显示指定ID的公文域 。 参数说明：无。 返回值说明： true 表示接口调用成功，功能能够实现； false
	 * 表示接口调用成功，功能未实现；
	 */
	this.showDocumentField = function(id, isvisible) {
		var app = this.getApp();
		if (app) {
			rs = app.showDocumentField(id);
		} else {
			var arr = [ id, isvisible ];
			this.execFunction("showDocumentField", arr);
		}
		return rs;
	};
	/**
	 * 功能说明： 设置公文域的值，替换旧数据。 返回值说明： true 表示接口调用成功，功能能够实现； false 表示接口调用失败，功能未能实现
	 */
	this.setDocumentField = function(id, value) {
		window.console && console.log("setDocumentField " + id + " : " + value);
		var app = this.getApp();
		if (app) {
			rs = app.setDocumentField(id, value);
		} else {
			var arr = [ id, value ];
			this.execFunction("setDocumentField", arr);
		}
		return rs;
	};
	/**
	 * 功能说明： 表格返回纯文本，图片不返回数据。 参数说明：id 要获取的公文域标识。 返回值说明： true 表示接口调用成功，功能能够实现；
	 * false 表示接口调用成功，功能未实现；
	 */
	this.getDocumentFieldValue = function(id) {
		var app = this.getApp();
		if (app) {
			rs = app.getDocumentFieldValue(id);
		} else {
			var arr = [ id ];
			this.execFunction("getDocumentFieldValue", arr);
		}
		return rs;
	};
	/**
	 * 功能说明： 设置指定公文域是有效 参数说明： id 要设置的公文域标识。 isenable 状态值 返回值说明： true
	 * 表示接口调用成功，功能能够实现； false 表示接口调用成功，功能未实现；
	 */
	this.enableDocumentField = function(id, isenable) {
		var app = this.getApp();
		if (app) {
			rs = app.enableDocumentField(id, isenable);
		} else {
			var arr = [ id, isenable ];
			this.execFunction("enableDocumentField", arr);
		}
		return rs;
	};
	/**
	 * 功能说明： 插入指定 id 里，内容全部换为文件的内容 参数说明： id 要设置的公文域标识。 fileNameURL 文件的链接地址
	 * 返回值说明： true 表示接口调用成功，功能能够实现； false 表示接口调用成功，功能未实现；
	 */
	this.insertDocument = function(id, fileNameURL) {
		var app = this.getApp();
		if (app) {
			rs = app.insertDocument(id, fileNameURL);
		} else {
			var arr = [ id, fileNameURL ];
			this.execFunction("insertDocument", arr);
		}
		return rs;
	};
	/***************************************************************************
	 * 将光标移动到指定名称公文域。 参数1：id公文域标识符；
	 * 参数2：position光标移动到公文域的位置，1指公文域标记前部，2指公文域标记后部，3指公文域文本前端，4指公文域文本后端 返回值说明：
	 * true表示接口调用成功，功能能够实现； false表示接口调用失败，功能未能实现。
	 **************************************************************************/
	this.cursorToDocumentField = function(id, pos) {
		window.console
				&& console.log("cursorToDocumentField " + id + " : " + pos);
		var app = this.getApp();
		var rs = false;
		if (app) {
			rs = app.cursorToDocumentField(id, pos);
		} else {
			var arr = [ id, pos ];
			rs = this.execFunction("cursorToDocumentField", arr);
		}
		return rs;
	};
	/** *************************************************标准定义接口结束*************************************************** */

	this.isLinux = function (){
		return this.os.indexOf('Linux') == 0
	}

	/** *************************************************金山定义接口开始*************************************************** */
	/**
	 * 高亮显示指定关键字
	 */
	this.markAll = function(key) {
		var app = this.getApp();
		var rs = false;
		if (app) {
			rs = app.Selection.Find.HitHighlight(key);
		} else {
			var arr = [ key ];
			rs = this.execFunction("app.Selection.Find.HitHighlight", arr);
		}
		return rs;
	}

	/**
	 * 执行一些无参数，无返回值的命令
	 */
	this.exeScript = function(val) {
		var app = this.getApp();
		var rs = false;
		if (app) {
			rs = eval("app." + val);
		} else {
			var arr = [];
			rs = this.execFunction("val", arr);
		}
		return rs;
	};

	/** 此方法还没有确定 */
	this.isProtected = function() {
		var rs = true;
		var app = this.getApp();
		if (app) {
			if (this.os.indexOf('Linux') == 0) {
				rs = app.ActiveDocument.ProtectionType;
			}

		} else {
			var arr = [];
			if (this.os.indexOf('Linux') == 0) {
				rs = this
						.execFunction("app.ActiveDocument.ProtectionType", arr);
			}

		}
		return rs;

	};
	/**
	 * 公文域输入模式 参数：enable 是否为输入模式；
	 */
	this.put_InsertionMode = function(enable) {
		var app = this.getApp();
		var rs = true;
		if (app) {
			if (this.os.indexOf('Linux') == 0) {
				rs = app.ActiveDocument.DocumentFields
						.put_InsertionMode(enable);
			}else{
				app.ActiveDocument.DocumentFields.InsertionMode = enable;
			}

		} else {
			var arr = [ enable ];
			if (this.os.indexOf('Linux') == 0) {
				rs = this.execFunction(
						"ActiveDocument.DocumentFields.put_InsertionMode", arr);
			}

		}
		return rs;
	};
	/**
	 * 设置当前文档类型 参数:类型值
	 */
	this.setDocumentType = function(type) {
		var app = this.getApp();
		var rs = false;
		if (app) {
			rs = app.setDocumentType(type);
		} else {
			var arr = [ type ];
			rs = this.execFunction("setDocumentType", arr);
		}
		return rs;
	};
	/**
	 * 删除选择中的单元格
	 *
	 */
	this.SelectionCellDelete = function(v) {
		var app = this.getApp();
		var rs = false;
		if (app) {
			if(this.os.indexOf('Win') == 0){
				if (app.DocObj.Application.Selection.Cells != null) {
					rs = app.DocObj.Application.Selection.Cells.Delete(v);//报错
				}
			}else{
				if(app.Selection.Cells != null){
					rs = app.Selection.Cells.Delete(v);
				}
			}
		} else {
			var arr = [ v ];
			rs = this.execFunction("DocObj.Application.Selection.Cells.Delete",
					arr);
		}
		return rs;
	};
	/**
	 * 多个公文域替换 参数1：tKey 公文域标识字符串 参数2：tValues 公文域值字符串 参数3：(?? 意义还不确定) 参数4：分隔符 *
	 */
	this.setDocumentMultiField = function(tKey, tValues, enable, sep) {
		var app = this.getApp();
		var rs = false;
		if (app) {
			rs = app.setDocumentMultiField(tKey, tValues, enable, sep);
		} else {
			var arr = [ tKey, tValues, enable, sep ];
			rs = this.execFunction("setDocumentMultiField", arr);
		}
		return rs;
	};
	/**
	 * 光标右移一个位置
	 */
	this.moveRight = function() {
		var rs = false;
		try {
			var app = this.getApp();
			if (app) {
				if(this.os.indexOf('Win') == 0){
					rs = app.ActiveDocument.ActiveWindow.Selection.MoveRight();
				}else{
					rs = app.get_ActiveDocument().get_ActiveWindow().get_Selection().MoveRight();
				}
			} else {
				var arr = [];
				rs = this
						.execFunction(
								"ActiveDocument.get_ActiveWindow().get_Selection().MoveRight",
								arr);
			}
		} catch (e) {
			return false;
		}
		return rs;

	};
	this.getPageCount = function() {

		var rs = 0;
		if (app) {
			if (this.os.indexOf('Linux') == 0) {
				rs = app.ActiveWindow.ActivePane.Pages.Count;
			}
		} else {
			var arr = [ enable ];
			if (this.os.indexOf('Linux') == 0) {
				rs = this.execFunction("ActiveWindow.ActivePane.Pages.Count",
						arr);
			}
		}
		return rs;
	};
	/**
	 * 设置版到偶数页
	 *
	 */
	this.setEditionToOOD = function() {
		var rs = true;
		if (app) {
			if (this.os.indexOf('Linux') == 0) {
				var pageSize = app.ActiveWindow.ActivePane.Pages.Count;
				if (pageSize % 2 > 0) {
					var tableCount = app.ActiveDocument.get_Tables()
							.get_Count();
					app.ActiveDocument.get_Tables().Item(tableCount).Select();
					app.Selection.InsertBreak();
				}
			}else if(this.os.indexOf('Win') == 0){
				var pageCount = app.ActiveDocument.ActiveWindow.ActivePane.Pages.Count;
				if (pageCount % 2 > 0)
				{
					var tableCount = app.ActiveDocument.Tables.Count;
					app.ActiveDocument.Tables(tableCount).Select;
					app.ActiveDocument.ActiveWindow.Selection.InsertBreak;
				}
			}
		} else {
			// var arr =[enable];
			// if (this.os.indexOf('Linux') == 0){
			// rs =
			// this.execFunction("app.ActiveWindow.ActivePane.Pages.Count",arr);
			// }
		}
		return rs;
	};

	/** 插入段落 */
	this.insertParagraph = function() {
		var rs = false;
		try {
			var app = this.getApp();
			if (app) {
				if(this.os.indexOf('Win') == 0){
					app.ActiveDocument.ActiveWindow.Selection.TypeParagraph();
				}else{
					app.ActiveDocument.get_ActiveWindow().get_Selection().TypeParagraph()
				}
			} else {
				var arr = [];
				rs = this.execFunction(
						"ActiveDocument.ActiveWindow.Selection.TypeParagraph",
						arr);
			}
		} catch (e) {
			return rs;
		}
	};
	/** 当前文档中是否存在指定公文域标识的公文域 */
	this.isExists = function(fieldid) {
		var rs = 0;
		var app = this.getApp();
		if (app) {
			rs = app.isExists(fieldid);
		} else {
			var arr = [ fieldid ];
			rs = this.execFunction("isExists", arr);
		}
		return rs;
	};

	/**
	 * 重命名公文域
	 */
	this.renameDocField = function(oldName,newName){
		var rs = 0;
		var app = this.getApp();
		if (app && newName != null && newName != "") {
			if(this.os.indexOf('Win') == 0){
				rs = app.DocObj.DocumentFields(oldName).Name = newName;
			}else{
				rs = app.ActiveDocument.DocumentFields.Item(oldName).put_Name(newName);
			}
		}else{
			var arr = [];
			rs = this.execFunction("renameDocField",arr);
		}
		return rs
	}
	/**
	 * 设置附件说明
	 *
	 * @param val
	 * @return
	 */
	this.setFuJianShuoMing = function(val) {
		var rs = fasle;
		var app = this.getApp();
		if (app) {
			if (val) {
				app.ActiveDocument.get_Tables().Item(2).Cell(2, 2).Select();
				app.insertText(val + "");
			} else {
				app.ActiveDocument.DocumentFields.Item("附件说明").Select();
				if(app.Selection.Cells != null){
					app.Selection.Cells.Delete(2);
				}
			}
			rs = true;
		} else {
			throw "设置附件说明出错，控件未初始化！";
		}
		return rs;

	};
	
	/**
	 * 选中某个书签
	 *
	 * @param val
	 * @return
	 */
	this.selectDocumentField = function(id) {
		var app = this.getApp();
		if (app) {
			if (this.os.indexOf('Linux') == 0) {
				app.ActiveDocument.DocumentFields.Item(id).Select();
			}else if(this.os.indexOf('Win') == 0){
				app.ActiveDocument.DocumentFields(id).Select();
			}
		} else {
			throw "控件未初始化！";
		}
	};
	
	/**
	 * 复制选中的内容格式
	 * PasteFormat
	 */
	this.CopyFormat = function(){
		if(this.os.indexOf('Win') == 0){
			app.ActiveDocument.Application.Selection.CopyFormat;
		}else{
			app.Selection.CopyFormat();
		}
	}
	
	/**
	 * 粘贴选中的内容格式
	 * PasteFormat
	 */
	this.PasteFormat = function(){
		if(this.os.indexOf('Win') == 0){
			app.ActiveDocument.Application.Selection.PasteFormat;
		}else{
			app.Selection.PasteFormat();
		}
	}
	

	/**
	 * 获取选中的对象
	 */
	this.getSelection = function(app){
		if(this.os.indexOf('Win') == 0){
			return app.ActiveDocument.Application.Selection;
		}else{
			return app.Selection;
		}
	}

	this.getParagraphs = function(app,i){
		if(this.os.indexOf('Win') == 0){
			return app.ActiveDocument.ActiveWindow.Selection.Paragraphs(i);
		}else{
			return app.Selection.Paragraphs.Item(i);
		}
	}

	/** 添加附件 */
	this.addAttachment = function(n, FJpath, FJSMpath,fileName,fileUrl) {
		var app = this.getApp();
		if (!app) {
			return false;
		}

		var ret,ret1,ret2,ret3;
		try
		{
			var wpsDocFileds = app.ActiveDocument.DocumentFields;
			try {
				var isExists = this.isExists("附件说明");//
			} catch (e) {
				isExists = false;
			}
			try {
				var isExists_2 = this.isExists("附注");//
			} catch (e) {
				isExists_2 = false;
			}
			if (n == 1 && !isExists && isExists_2){//模板中没有附件,有附注
				app.ActiveDocument.ActiveWindow.Selection.EndKey();
				this.cursorToDocumentField("附注",2);
				var selection = app.ActiveDocument.ActiveWindow.Selection;
				var start = selection.Start;
				var end = selection.End;
				wpsDocFileds.InsertionMode = false;
				selection.Start = end;
				selection.End = end;

				//光标右移
				ret = this.moveRight();
				if (ret){
					app.ActiveDocument.ActiveWindow.Selection.InsertBreak();//undefine
					app.ActiveDocument.ActiveWindow.Selection.InsertFile(FJpath);
					this.renameDocField("附件_0","附件");
					this.renameDocField("FJ_标题_0","FJ_标题");
					this.renameDocField("FJ_正文_0","FJ_正文");

					this.cursorToDocumentField("正文",2);
					var selection = app.ActiveDocument.ActiveWindow.Selection;
					var start = selection.Start;
					var end = selection.End;
					wpsDocFileds.InsertionMode = false;
					selection.Start = end;
					selection.End = end;
					ret1 = true;
					if (!ret1)
						return false;
					app.ActiveDocument.ActiveWindow.Selection.InsertFile(FJSMpath);  //正文后插入附件说明
					var value = this.getDocumentFieldValue("FJ_标题");
					this.setDocumentField("附件说明", value);

					//删除多余行
					this.cursorToDocumentField("附件说明",2);
					var selection = app.ActiveDocument.ActiveWindow.Selection;
					var start = selection.Start;
					var end = selection.End;
					wpsDocFileds.InsertionMode = false;
					selection.Start = end;
					selection.End = end;
					app.ActiveDocument.ActiveWindow.Selection.MoveDown(5,1,0);
					var count = app.Selection.Paragraphs.Count;
					for(var k=0; k<2; k++)
					{
						for (var i = count;i > 0;i--)
							this.getParagraphs(app,i).Range.Delete();
					}
					return true;
				}
			}
			if (n == 1 && !isExists && !isExists_2){//模板中没有附件,没有附注
				app.ActiveDocument.ActiveWindow.Selection.EndKey();
				try {
					var isExists_3 = wpsDocFileds.Exists("成文日期");
				} catch (e) {
					isExists_3 = false;
				}
				try {
					var isExists_4 = wpsDocFileds.Exists("印发日期");
				} catch (e) {
					isExists_4 = false;
				}
				if(isExists_3){ //模板10和17
					this.cursorToDocumentField("成文日期",2);
					var selection = app.ActiveDocument.ActiveWindow.Selection;
					var start = selection.Start;
					var end = selection.End;
					wpsDocFileds.InsertionMode = false;
					selection.Start = end;
					selection.End = end;

					//光标下移
					ret = app.ActiveDocument.ActiveWindow.Selection.MoveDown(5,1,0);
					app.ActiveDocument.ActiveWindow.Selection.InsertBreak();//undefined
					app.ActiveDocument.ActiveWindow.Selection.InsertFile(FJpath);
				}
				else if(!isExists_3 && isExists_4)  //模板7
				{
					try
					{
						var isExists_5 = wpsDocFileds.Exists("抄送机关_1");
					}
					catch(e)
					{
						isExists_5 =  false;
					}
					if (isExists_5)
					{
						this.cursorToDocumentField("抄送机关_1",2);
						var selection = app.ActiveDocument.ActiveWindow.Selection;
						var start = selection.Start;
						var end = selection.End;
						wpsDocFileds.InsertionMode = false;
						selection.Start = start;
						selection.End = start;
					}
					//标准模板版记上有三个2个空行，故moveup()
					ret = app.ActiveDocument.ActiveWindow.Selection.MoveUp();
					ret = app.ActiveDocument.ActiveWindow.Selection.MoveUp();
					ret = app.ActiveDocument.ActiveWindow.Selection.MoveUp();
					app.ActiveDocument.ActiveWindow.Selection.InsertBreak();//undefine
					app.ActiveDocument.ActiveWindow.Selection.InsertFile(FJpath);
				}
				else  //模板6
				{
					this.cursorToDocumentField("正文",2);
					var selection = app.ActiveDocument.ActiveWindow.Selection;
					var start = selection.Start;
					var end = selection.End;
					wpsDocFileds.InsertionMode = false;
					selection.Start = end;
					selection.End = end;

					app.ActiveDocument.ActiveWindow.Selection.InsertBreak();//undefine
					app.ActiveDocument.ActiveWindow.Selection.InsertFile(FJpath);
				}
				this.renameDocField("附件_0","附件");
				this.renameDocField("FJ_标题_0","FJ_标题");
				this.renameDocField("FJ_正文_0","FJ_正文");
				this.cursorToDocumentField("正文",2);
				var selection = app.ActiveDocument.ActiveWindow.Selection;
				var start = selection.Start;
				var end = selection.End;
				wpsDocFileds.InsertionMode = false;
				selection.Start = end;
				selection.End = end;
				app.ActiveDocument.ActiveWindow.Selection.InsertFile(FJSMpath);  //正文后插入附件说明
				var value = this.getDocumentFieldValue("FJ_标题");
				this.setDocumentField("附件说明", value);


				//删除多余行
				this.cursorToDocumentField("附件说明",2);
				var selection = app.ActiveDocument.ActiveWindow.Selection;
				var start = selection.Start;
				var end = selection.End;
				wpsDocFileds.InsertionMode = false;
				selection.Start = end;
				selection.End = end;

				app.ActiveDocument.ActiveWindow.Selection.MoveDown(5,1,0);
				var count = app.ActiveDocument.ActiveWindow.Selection.Paragraphs.Count;
				for (var i = count;i > 0;i--)
					this.getParagraphs(app,i).Range.Delete();

				return true;

			}
			if (isExists && n == 2)  //模板中有模板
			{
				this.renameDocField("附件","附件_1");
				this.renameDocField("FJ_标题","FJ_标题_1");
				this.renameDocField("FJ_正文","FJ_正文_1");
			}
			var FJZW = "FJ_正文_" + (n-1);
			try
			{
				var isExists = wpsDocFileds.Exists(FJZW);
			}
			catch(e)
			{
				isExists =  false;
			}
			if (!isExists)
				return false;

			this.cursorToDocumentField(FJZW,2);
			var selection = app.ActiveDocument.ActiveWindow.Selection;
			var start = selection.Start;
			var end = selection.End;
			wpsDocFileds.InsertionMode = false;
			selection.Start = end;
			selection.End = end;
			ret = true;
			if (ret)
			{
				app.ActiveDocument.ActiveWindow.Selection.InsertBreak();
				app.ActiveDocument.ActiveWindow.Selection.InsertFile(FJpath);
				this.renameDocField("附件_0","附件_" + n);
				this.renameDocField("FJ_标题_0","FJ_标题_" + n);
				this.renameDocField("FJ_正文_0","FJ_正文_" + n);

				var value = this.getDocumentFieldValue("FJ_标题_" + n);

				this.cursorToDocumentField("附件说明",2);
				var selection = app.ActiveDocument.ActiveWindow.Selection;
				var start = selection.Start;
				var end = selection.End;
				wpsDocFileds.InsertionMode = true;
				selection.Start = end;
				selection.End = end;
				var retCur = true;

				if (retCur)
				{
					this.insertParagraph();
					app.ActiveDocument.ActiveWindow.Selection.Text = value;
					return true;
				}
			}
			return false;
		}
		catch(e)
		{
			return false;
		}

		try {
			var isExists = this.isExists("附件说明");
			var isExists_2 = this.isExists("附注");
			if (n == 1 && !isExists && isExists_2)// 模板中没有附件,有附注
			{
				app.DocObj.Application.Selection.EndKey();
				ret = this.cursorToDocumentField("附注", 2); // 附注后插入附件
				// 光标右移
				ret = this.moveRight();
				if (ret) {
					app.DocObj.Application.Selection.InsertBreak();// undefine
					app.ActiveDocument.ActiveWindow.Selection
							.InsertFile(FJpath);
					ret1 = this.renameDocField("附件_0", "附件");
					ret2 = this.renameDocField("FJ_标题_0", "FJ_标题");
					ret3 = this.renameDocField("FJ_正文_0", "FJ_正文");
					if (!ret1 || !ret2 || !ret3)
						return false;

					ret1 = this.cursorToDocumentField("正文", 2);
					if (!ret1)
						return false;
					app.ActiveDocument.ActiveWindow.Selection
							.InsertFile(FJSMpath); // 正文后插入附件说明
					var value = this.getDocumentFieldValue("FJ_标题");
					ret1 = this.setDocumentField("附件说明", value);
					if (!ret1)
						return false;

					// 删除多余行
					this.cursorToDocumentField("附件说明", 2);
					app.DocObj.Application.Selection.MoveDown(5, 1, 0);
					for (var k = 0; k < 2; k++) {
						var count = app.DocObj.Application.Selection.Paragraphs.Count;
						for (var i = count; i > 0; i--)
							this.getParagraphs(app,i).Range
									.Delete();
					}

					return true;
				}
			}
			if (n == 1 && !isExists && !isExists_2)// 模板中没有附件,没有附注
			{

				app.DocObj.Application.Selection.EndKey();

				var isExists_3 = app.isExists("成文日期");
				var isExists_4 = app.isExists("印发日期");
				if (isExists_3) // 模板10和17
				{
					ret = this.cursorToDocumentField("成文日期", 2);
					// 光标下移
					ret = app.ActiveDocument.ActiveWindow.Selection.MoveDown(5,
							1, 0);
					app.DocObj.Application.Selection.InsertBreak();// undefine
					app.ActiveDocument.ActiveWindow.Selection
							.InsertFile(FJpath);
				} else if (!isExists_3 && isExists_4) // 模板7
				{
					this.cursorToDocumentField("抄送机关_1", 1);
					ret = app.ActiveDocument.Application.Selection.MoveUp();
					ret = app.ActiveDocument.Application.Selection.MoveUp();
					app.DocObj.Application.Selection.InsertBreak();// undefine
					app.ActiveDocument.ActiveWindow.Selection
							.InsertFile(FJpath);
				} else // 模板6
				{
					this.cursorToDocumentField("正文", 2);
					app.DocObj.Application.Selection.InsertBreak();// undefine
					app.ActiveDocument.ActiveWindow.Selection
							.InsertFile(FJpath);
				}

				ret1 = this.renameDocField("附件_0", "附件");
				ret2 = this.renameDocField("FJ_标题_0", "FJ_标题");
				ret3 = this.renameDocField("FJ_正文_0", "FJ_正文");
				if (!ret1 || !ret2 || !ret3)
					return false;

				ret1 = this.cursorToDocumentField("正文", 2);
				if (!ret1)
					return false;
				app.ActiveDocument.ActiveWindow.Selection.InsertFile(FJSMpath); // 正文后插入附件说明
				var value = this.getDocumentFieldValue("FJ_标题");
				ret1 = this.setDocumentField("附件说明", value);
				if (!ret1)
					return false;

				// 删除多余行
				this.cursorToDocumentField("附件说明", 2);
				app.DocObj.Application.Selection.MoveDown(5, 1, 0);
				for (var k = 0; k < 2; k++) {
					var count = app.DocObj.Application.Selection.Paragraphs.Count;
					for (var i = count; i > 0; i--)
						this.getParagraphs(app,i).Range.Delete();
				}

				return true;

			}
			if (isExists && n == 2) // 模板中有模板
			{
				ret1 = this.renameDocField("附件", "附件_1");
				ret2 = this.renameDocField("FJ_标题", "FJ_标题_1");
				ret3 = this.renameDocField("FJ_正文", "FJ_正文_1");
				if (!ret1 || !ret2 || !ret3)
					return false;
			}
			var FJZW = "FJ_正文_" + (n - 1);
			var isExists = this.isExists(FJZW);
			if (!isExists)
				return false;

			var ret = this.cursorToDocumentField(FJZW, 2);
			if (ret) {
				app.DocObj.Application.Selection.InsertBreak();
				app.ActiveDocument.ActiveWindow.Selection.InsertFile(FJpath);
				ret1 = this.renameDocField("附件_0", "附件_" + n);
				ret2 = this.renameDocField("FJ_标题_0", "FJ_标题_" + n);
				ret3 = this.renameDocField("FJ_正文_0", "FJ_正文_" + n);
				if (!ret1 || !ret2 || !ret3)
					return false;
				var value = this.getDocumentFieldValue("FJ_标题_" + n);
				var retCur = this.cursorToDocumentField("附件说明", 4);
				if (retCur) {
					ret = this.insertParagraph();
					if (ret)
						ret = this.insertText(value);
					if (ret)
						return true;
				}
			}
			return false;
		} catch (e) {
			return false;
		}
	};
	this.msgObj = {
		backupIds : ""
	};
	this._fileType = ".doc";
	this.WebSetMsgByName = function(key, value) {
		if ((key != "") && (value != "")) {
			this.msgObj[key] = value;
		}
	};
	this.WebGetMsgByName = function(key) {
		if (key != "") {
			return this.msgObj[key];
		}
		return null;
	};
	this.setFileType = function(type) {
		if (type != null && type != "") {
			this._fileType = type;
		}
	};
	this.getFileType = function() {
		return this._fileType;
	};
	// -1表示没有安装Office2007,4表示设置功能区最小化,0设置功能区最大化
	this.Office2007Ribbon = function() { // -1表示没有安装Office2007,4表示设置功能区最小化,0设置功能区最大化
		return -1;
	};
	this.DisableMenu = function(_id) {
		if (_id == 200) {
			return getOfficeLanguage("menu_CurrentVer");
		} else if (_id == 201) {
			return getOfficeLanguage("menu_Ver1");
		} else if (_id == 202) {
			return getOfficeLanguage("menu_Ver2");
		} else if (_id == 203) {
			return getOfficeLanguage("menu_Ver3");
		} else if (_id == 204) {
			return getOfficeLanguage("menu_Ver4");
		} else if (_id == 205) {
			return getOfficeLanguage("menu_Ver5");
		}

	};
	this.EnableMenu = function(enable) {
		// 设置菜单 是否有效

	};
	this.AppendMenu = function(i, verMenuName, imgId) {
		// alert("seeyon_office.js函数this.AppendMenu..待实现");
	};
	this.VersionEx = function() {
		// alert("seeyon_office.js函数this.VersionEx..待实现");
	};
	// pwd=""表示密码为系统默认
	this.WebSetProtect = function(isdefaut, pwd) {
		// alert("seeyon_office.js函数this.WebSetProtect..待实现");
	};
	var _editType = "";
	this.setEditType = function(type) {
		_editType = type;
	};
	this.getEditType = function() {
		return _editType;
	};
	var _showType = "";
	this.getShowType = function() {
		return _showType;
	};
	this.setShowType = function(type) {
		_showType = type;
	};
	this.WebShowSignature = function() {
		// alert("seeyon_office.js函数this.WebShowSignature..待实现");
	};
	var _lastType = "";
	this.getLastType = function() {
		return _lastType;
	};
	this.setLastType = function(_type) {
		_lastType = _type;
	};
	this.WebOpen = function() {
		// alert("seeyon_office.js函数this.WebOpen..待实现");
	};
	var _signatureCount = false;
	this.getSignatureCount = function(isenable) {
		// //alert("seeyon_office.js函数this.getSignatureCount..待实现");
		return 0;// _signatureCount = 0;
	};
	this.setAttribute = function(key, value) {

	};
	this.alert = function(msg) {
		alert(msg);
	};
	this.Version = function() {
		return false;
	};
	/** 根据扩展名判断，是否安装了某个软件，如.eio为永中 */
	this.WebApplication = function(exname) {
		return false;
	};
	this.WebSave = function() {
		// 执行默认保存
		return true;
	};
	this.WebGetBookMarks = function(id) {
		var _id = id;
		if (id.search("my:") != -1) {
			_id = getLabelNameById(_id);
		}
		var fieldValue = this.getDocumentFieldValue(id);
		if (_id == id) { // 没有找到或本就是汉字

		}

		if ("copies" == id) {
			return 1;
		} else if ("date20" == id) {
			return "20150525";
		}
		return ""
	};
	this.WebSetBookmarks = function(label, content) {
		return true;
	};

	/**
	 * 接受所有修订
	 */
	this.acceptAllRevisions = function(){
		var rs = false;
		var app = this.getApp();
		if (app) {
			if(this.os.indexOf('Win') == 0){
				var doc = app.ActiveDocument;
				rs = doc.AcceptAllRevisions();
			}else{
				var doc = app.Documents.ActiveDocument();
				rs = doc.AcceptAllRevisions();
			}
		} else {
			rs = this.execFunction("acceptAllCommand", null);
		}
		return rs;
	}
	/**
	 * 删除所有批注
	 */
	this.deleteAllComments = function(){
		var rs = false;
		var app = this.getApp();
		if (app) {
			rs = app.ActiveDocument.DeleteAllComments();
		} else {
			rs = this.execFunction("deleteAllComments", null);
		}
		return rs;
	}
	/**
	 * 当前文档全屏编辑
	 */
	this.FullScreen = function(v) {
		var rs = false;
		var app = this.getApp();
		if (app) {
			rs = app.FullScreen(v);
		} else {
			var arr = [ v ];
			rs = this.execFunction("FullScreen", arr);
		}
		return rs;

	};
	this.WebInsertFile = function() {
		return true;
	};
	// 设置痕迹是显示
	this.WebSetRevision = function(bool1, bool2, bool3, isShowShenYueMenu) {

	};
	this.WebLoadTemplate = function() {
		if (this.isLoadTemplate == true) {
			return true;
		}
		if (this.Template != "") {
			this.isLoadTemplate = ocxObj.openDocumentRemote(this.Template,
					false);
			if (this.isLoadTemplate) {
				this.WebObject = ocxObj.getApp().ActiveDocument;
			}
		}
		return this.isLoadTemplate;
	};
	this.HandleSecretLevel = function() {
		/*
		 * var Selection=this.getApp().Selection; //获取select对象 var BookmarkStart =
		 * this.WebObject.Bookmarks("secret_level").end; //获取密级书签后索引 var
		 * BookmarkEnd = this.WebObject.Bookmarks("keep_period").end;
		 * //获取年限书签前索引 Selection.SetRange(BookmarkStart,BookmarkEnd); //选中正文信息
		 * Selection.Text=""; //将空格删掉
		 */
	};
	this.getRealKey = function(key) {
		var _key = key;
		if (key.search("doc_mark") != -1) {
			_key = "fawenhao";//
		} else if (key.search("urgent_level") != -1) {//紧急程度
			_key = "jinjidu";
		} else if (key.search("send_unit") != -1) {//发文机关名称
			_key = "zhuanwendanweimingcheng";
		} else if (key.search("secret_level") != -1) {//密级
			_key = "miji";
		} else if (key.search("signing_date") != -1) {//
			_key = "yinfariqi";
		} else if (key.search("create_person") != -1) {
			_key = "fawenjiguan";
		} else if (key.search("copies") != -1) {//份号
			_key = "fenhao";
		} else if (key.search("subject") != -1) {//标题
			_key = "biaoti";
		} else if (key.search("send_to") != -1) {//主送机关
			_key = "zhusongdanwei";
		} else if (key.search("copy_to") != -1) {//抄送机关
			_key = "chaosongdanwei";
		} else if (key.search("attachments") != -1) {
			_key = "fujian";
		}else if (key.search("keep_period") != -1) {//保密期限
			_key = "nianxian";
		}
		return _key;
	};
	this.getLabelNameById = function(key) {
		if (key == null) {
			return null;
		}
		;
		var rs = key;
		if (key.search("copies") != -1) {
			rs = "份号";//
		} else if (key.search("copy_to") != -1) {
			rs = "抄送机关";
		} else if (key.search("create_person") != -1) {
			rs = "拟稿";
		} else if (key.search("doc_mark") != -1) {
			rs = "发文字号";
		} else if (key.search("doc_type") != -1) {
			rs = "文种";// 公文种类
		} else if (key.search("huiqian") != -1) {
			rs = "会签";
		} else if (key.search("keyword") != -1) {
			rs = "主题词";
		} else if (key.search("otherOpinion") != -1) {
			rs = "处理意见";
		} else if (key.search("packdate") != -1) {
			rs = "封发时间";
		} else if (key.search("print_unit") != -1) {
			rs = "印发机关";
		} else if (key.search("qianfa") != -1) {
			rs = "签发";
		} else if (key.search("report_to") != -1) {
			rs = "抄报";
		} else if (key.search("secret_level") != -1) {
			rs = "密级";
		} else if (key.search("send_to") != -1) {
			rs = "主送机关";
		} else if (key.search("send_type") != -1) {
			rs = "行文类型";
		} else if (key.search("send_unit") != -1) {
			rs = "拟稿单位";
		} else if (key.search("serial_no") != -1) {
			rs = "内部文号";
		} else if (key.search("shenhe") != -1) {
			rs = "审核";
		} else if (key.search("subject") != -1) {
			rs = "标题";
		} else if (key.search("urgent_level") != -1) {
			rs = "紧急程度";//
		}
		if (key.indexOf("2") != -1) { // 公文文号B
			rs = rs + "B";
		}
		return rs;
	};

	this.setUserName = function(userName){
		var rs = 0;
		var app = this.getApp();
		if (app) {
			rs = app.setUserName(userName);
		} else {
			var arr = [ userName ];
			rs = this.execFunction("setUserName", arr);
		}
		return rs;
	};
	
	this.SetFileSubmenuItemsVisible = function(item){
		if (ocx == null || ocx == undefined) {
			ocx = document.getElementById(currObjectId);
		}
		if (ocx) {
			if(this.os.indexOf( "Win")!=-1){
				ocx.FileSubmenuItems |= item;
			}else if(this.os == "Linux"){
				if(item == 1){
					var Interval_control1 = setInterval(
						function () {
							app = ocx.Application;
							if (app && app.IsLoad()) {
								app.get_CommandBars().get_Item('Menu Bar').Controls.get_Item('文件(&F)').Controls.get_Item('新建(&N)...').Visible = true;
								clearInterval(Interval_control1);
							}
						}, 500);
				}else if(item == 2){
					var Interval_control2 = setInterval(
						function () {
							app = ocx.Application;
							if (app && app.IsLoad()) {
								app.get_CommandBars().get_Item('Menu Bar').Controls.get_Item('文件(&F)').Controls.get_Item('打开(&O)...').Visible = true;
								clearInterval(Interval_control2);
							}
						}, 500);
				}else if(item == 4){
					var Interval_control4 = setInterval(
						function () {
							app = ocx.Application;
							if (app && app.IsLoad()) {
								app.get_CommandBars().get_Item('Menu Bar').Controls.get_Item('文件(&F)').Controls.get_Item('退出(&X)').Visible = true;
								clearInterval(Interval_control4);
							}
						}, 500);
				}else if(item == 8){
					var Interval_control8 = setInterval(
						function () {
							app = ocx.Application;
							if (app && app.IsLoad()) {
								app.get_CommandBars().get_Item('Menu Bar').Controls.get_Item('文件(&F)').Controls.get_Item('保存(&S)').Visible = true;
								app.get_CommandBars().get_Item('Menu Bar').Controls.get_Item('文件(&F)').Controls.get_Item('保存所有文档(&E)').Visible = true;
								clearInterval(Interval_control8);
							}
						}, 500);
				}else if(item == 16){
					var Interval_control16 = setInterval(
						function () {
							app = ocx.Application;
							if (app && app.IsLoad()) {
								app.get_CommandBars().get_Item('Menu Bar').Controls.get_Item('文件(&F)').Controls.get_Item('另存为(&A)...').Visible = true;
								app.get_CommandBars().get_Item('Menu Bar').Controls.get_Item('文件(&F)').Controls.get_Item('输出为PDF格式(&F)...').Visible = true;
								app.get_CommandBars().get_Item('Menu Bar').Controls.get_Item('文件(&F)').Controls.get_Item('输出为OFD格式(&G)...').Visible = true;
								clearInterval(Interval_control16);
							}
						}, 500);
				}else if(item == 64){
					var Interval_control64 = setInterval(
						function () {
							app = ocx.Application;
							if (app && app.IsLoad()) {
								app.get_CommandBars().get_Item('Menu Bar').Controls.get_Item('文件(&F)').Controls.get_Item('打印(&P)...').Visible = true;
								app.get_CommandBars().get_Item('Menu Bar').Controls.get_Item('文件(&F)').Controls.get_Item('打印预览(&V)').Visible = true;
								clearInterval(Interval_control64);
							}
						}, 500);
				}
			}
		}
	};
	this.SetFileSubmenuItemsHidden = function(item){
		if (ocx == null || ocx == undefined) {
			ocx = document.getElementById(currObjectId);
		}
		if (ocx) {
			if(this.os.indexOf('Win') == 0){
				ocx.FileSubmenuItems &= ~item;
			}else if(this.os == "Linux"){
				if(item == 1){
					var Interval_control1 = setInterval(
						function () {
							app = ocx.Application;
							if (app && app.IsLoad()) {
								app.get_CommandBars().get_Item('Menu Bar').Controls.get_Item('文件(&F)').Controls.get_Item('新建(&N)...').Visible = false;
								app.get_CommandBars().get_Item('Standard').Controls.get_Item('新建(&N)...').Visible = false;
								clearInterval(Interval_control1);
							}
						}, 500);
				}else if(item == 2){
					var Interval_control2 = setInterval(
						function () {
							app = ocx.Application;
							if (app && app.IsLoad()) {
								app.get_CommandBars().get_Item('Menu Bar').Controls.get_Item('文件(&F)').Controls.get_Item('打开(&O)...').Visible = false;
								app.get_CommandBars().get_Item('Standard').Controls.get_Item('打开(&O)...').Visible = false;
								clearInterval(Interval_control2);
							}
						}, 500);
				}else if(item == 4){
					var Interval_control4 = setInterval(
						function () {
							app = ocx.Application;
							if (app && app.IsLoad()) {
								app.get_CommandBars().get_Item('Menu Bar').Controls.get_Item('文件(&F)').Controls.get_Item('退出(&X)').Visible = false;
								clearInterval(Interval_control4);
							}
						}, 500);
				}else if(item == 8){
					var Interval_control8 = setInterval(
						function () {
							app = ocx.Application;
							if (app && app.IsLoad()) {
								app.get_CommandBars().get_Item('Menu Bar').Controls.get_Item('文件(&F)').Controls.get_Item('保存(&S)').Visible = false;
								app.get_CommandBars().get_Item('Menu Bar').Controls.get_Item('文件(&F)').Controls.get_Item('保存所有文档(&E)').Visible = false;
								app.get_CommandBars().get_Item('Standard').Controls.get_Item('保存(&S)').Visible = false;
								clearInterval(Interval_control8);
							}
						}, 500);
				}else if(item == 16){
					var Interval_control16 = setInterval(
						function () {
							app = ocx.Application;
							if (app && app.IsLoad()) {
								app.get_CommandBars().get_Item('Menu Bar').Controls.get_Item('文件(&F)').Controls.get_Item('另存为(&A)...').Visible = false;
								app.get_CommandBars().get_Item('Menu Bar').Controls.get_Item('文件(&F)').Controls.get_Item('输出为PDF格式(&F)...').Visible = false;
								app.get_CommandBars().get_Item('Menu Bar').Controls.get_Item('文件(&F)').Controls.get_Item('输出为OFD格式(&G)...').Visible = false;
								app.get_CommandBars().get_Item('Standard').Controls.get_Item('输出为PDF格式(&F)...').Visible = false;
								clearInterval(Interval_control16);
							}
						}, 500);
				}else if(item == 64){
					var Interval_control64 = setInterval(
						function () {
							app = ocx.Application;
							if (app && app.IsLoad()) {
								app.get_CommandBars().get_Item('Menu Bar').Controls.get_Item('文件(&F)').Controls.get_Item('打印(&P)...').Visible = false;
								app.get_CommandBars().get_Item('Menu Bar').Controls.get_Item('文件(&F)').Controls.get_Item('打印预览(&V)').Visible = false;
								app.get_CommandBars().get_Item('Standard').Controls.get_Item('打印(&P)').Visible = false;
								app.get_CommandBars().get_Item('Standard').Controls.get_Item('打印预览(&V)').Visible = false;
								clearInterval(Interval_control64);
							}
						}, 500);
				}
			}
		}
	};
};
var seeyon_wps = {};
var yozo = {};
var cpcnswp = {};
seeyon_wps.init = function(tagID, width, height) {
	var obj = new WP.OBJ('WPS');
	obj.init(tagID, width, height);
	return obj;
};
yozo.init = function(tagID, width, height) {
	var obj = new WP.OBJ('YOZO');
	obj.init(tagID, width, height);
	return obj;
};
